;Battery test v2.0 by Philip Graf
;12.98

#include "usgard.h"             ;only for usgard, as you can see

.org 0
title:  .db "BATTERY TEST v2.0",0

	call CLEARLCD
	#fncall gray_on         ;switch grayscale on
	ld hl,$0200                 ;X=2,Y=0
	ld de,&title
	call &writexy
	ld hl,$0107
	ld de,&copystr
	call &writexy
	ld a,$FF                    ;Bitmap blackline
	ld de,$80                 ;row 8 (FC00h+8*16)
	call &horizline
	ld de,$360                 ;row 54
	call &horizline
	ld hl,$0A08                 ;X=8,Y=10
	ld de,&infostr
	call &writexymnu
	ld hl,$1E08                 ;X=8,Y=30
	ld de,&batstr
	call &writexymnu
	ld hl,&bar              ;draw bar
	ld de,$feb3
	ld bc,$2d
	ldir
	ld hl,$2916             ;write "0%"
	ld de,&zstr
	call &writexymnu
	ld hl,$2963             ;write "100%"
	ld de,&hstr
	call &writexymnu
fadein:                             ;fade in            
	ld a,($8007)
	jr z,chkbat
	ld b,a
	xor a
fi:     out (2),a
	inc a
	call &delay
	djnz fi
chkbat:                             ;check battery (in fact contrast ;)!)
	ld a,($8007)                ;load contrast value (between 0 and 31)
	ld de,&min
	cp $18
	jr nc,cl1
	ld de,&bad        
cl1:    cp $10
	jr nc,cl2
	ld de,&mod
cl2:    cp $08
	jr nc,cl3
	ld de,&good
cl3:    or a
	jr nz,cl4
	ld de,&fant
cl4:    cp $1F                          
	jr nz,cl5
	ld de,&newones
cl5:    ld hl,$1E46
	call &writexymnu           ;write battery condition
	ld hl,$1E08
	ld de,&batstr
	call &writexymnu
	ld hl,(PAGE2ADDR)       ;copy PAGE1 to PAGE2
	ex de,hl
	ld hl,$fc00
	ld bc,1024
	ldir
	call &drawbar
keyloop:                            ;repeat until keypressed
	call GET_KEY
	cp $37                      ;Exit key
	jr z,fadeout
	cp $04                      ;Up-arrow key
	jr z,up
	cp $01                      ;Down-arrow key
	jr z,down
	jr keyloop

fadeout:                            ;fade out and exit program
	ld a,($8007)
	or a
	jr z,fo1                    ;don't fade if contrast's already 0
	ld b,a
fo:     out (2),a
	dec a
	call &delay
	djnz fo
	ld a,($8007)
	out (2),a
fo1:    
	#fncall gray_off            ;switch grayscale off       
	ret                         ;exit program

writexy:                            ;write text in normal style
	ld ($800C),hl
	ex de,hl
	call D_ZT_STR
	ret
writexymnu:                         ;write text in menu style
	ld ($8333),hl
	ex de,hl
	call D_ZM_STR
	ret
horizline:
	ld hl,$fc00
	add hl,de
	ld b,16                     ;set 16 bytes (a horizontal line) to 
hlo:    ld (hl),a                   ;bitmap stored in a    
	inc hl
	djnz hlo
	;ld hl,(PAGE2ADDR)
	;add hl,de
	;ld b,16
hlo1:   ;ld (hl),a
	;inc hl
	;djnz hlo1
	ret
down:
	ld a,($8007)
	or a                       ;0 is minimum contrast
	jr z,keyloop
	dec a
	jr upndown
up:                                 
	ld a,($8007)                 
	cp $1F                      ;1Fh is maximum contrast
	jr z,keyloop
	inc a
upndown:ld ($8007),a
	out (2),a                   ;update contrast
	xor a                       ;Bitmap whiteline   
	ld de,$1F0                 ;clear old battery condition
	call &horizline
	ld de,$200
	call &horizline
	ld de,$210
	call &horizline
	ld de,$220
	call &horizline
	ld de,$230
	call &horizline
	jp &chkbat                 ;write new battery condition

delay:
	push bc
	push af
	ld bc,$20FF
ldel:   ;nop
	dec bc
	ld a,b
	or c
	jr nz,ldel
	pop af
	pop bc
	ret

drawbar:
	ld b,8
	ld hl,(PAGE2ADDR)
	ld de,$2c4
	add hl,de
	ld de,$fec4
db2:    ld (hl),0
	inc hl
	ex de,hl
	ld (hl),0
	inc hl
	ex de,hl
	djnz db2
	ld a,($8007)
	ld b,a
	ld a,31
	sub b
	sra a
	sra a
	or a
	ret z
	ld b,a
	ld hl,$fec4
db1:    ld (hl),$ff
	inc hl
	djnz db1
	ld hl,(PAGE2ADDR)
	ld de,$2c4
	add hl,de
	add a,l
	ld l,a
	ld (hl),$ff
	ret

bar:    .db 1,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,%10000000,0,0,0
	.db 0,0,0,1,0,0,0,0,0,0,0,0,%10000000,0,0,0
	.db 0,0,0,1,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,%10000000,0,0,0

infostr:.db "Use arrowkeys to" 
	.db " change contrast.",0
hstr:   .db "100%",0
zstr:   .db "0%",0
batstr: .db "Battery condition:",0
min:    .db "Minimum",0
bad:    .db "Bad",0
mod:    .db "Moderate",0
good:   .db "OK",0
fant:   .db "Fantastic",0
newones:.db "Insert new ones",0
copystr:.db "(c) by  Philip Graf",0

.END
